package se.chalmers.tdv.queue;

import java.util.Random;

public class QueueAction {

	public enum ActionType {
		ISEMPTY, ADD, FRONT, REMOVE, OUTPUT
	};

	public ActionType type;
	public Integer value;

	public QueueAction(ActionType type, Integer value) {
		this.type = type;
		this.value = value;
	}

	public String toString() {
		switch (this.type) {
		case ISEMPTY:
			return "isEmpty()";
		case ADD:
			return "add(" + this.value + ")";
		case FRONT:
			return "front()";
		case REMOVE:
			return "remove()";
		case OUTPUT:
			return "output(" + this.value + ")";
		default:
			throw new RuntimeException("Unknown action type.");
		}
	}



	public static QueueAction[] randomActions(int n) {
		QueueAction[] result = new QueueAction[n];
		Random rand = new Random();
		for (int i = 0; i < n; i++) {
			switch (rand.nextInt(3)) {
			case 0:
				result[i] = new QueueAction(ActionType.REMOVE,0);
				break;
			case 1:
				result[i] = new QueueAction(ActionType.ADD,rand.nextInt(20));
				break;
			case 2:
				result[i] = new QueueAction(ActionType.FRONT,0);
			}
		}
		return result;
	}

}
